diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/examples/wifi-bianchi.cc ns-3.34/src/wifi/examples/wifi-bianchi.cc
--- ns-3.33/src/wifi/examples/wifi-bianchi.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/examples/wifi-bianchi.cc	2021-07-14 10:31:07.000000000 -0700
@@ -428,8 +556,17 @@
 }
 
 void
-TracePacketReception (std::string context, Ptr<const Packet> packet, uint16_t channelFreqMhz, WifiTxVector txVector, MpduInfo aMpdu, SignalNoiseDbm signalNoise, uint16_t staId)
+TracePacketReception (std::string context, Ptr<const Packet> p, uint16_t channelFreqMhz, WifiTxVector txVector, MpduInfo aMpdu, SignalNoiseDbm signalNoise, uint16_t staId)
 {
+  Ptr<Packet> packet = p->Copy ();
+  if (txVector.IsAggregation ())
+    {
+      AmpduSubframeHeader subHdr;
+      uint32_t extractedLength;
+      packet->RemoveHeader (subHdr);
+      extractedLength = subHdr.GetLength ();
+      packet = packet->CreateFragment (0, static_cast<uint32_t> (extractedLength));
+    }
   WifiMacHeader hdr;
   packet->PeekHeader (hdr);
   // hdr.GetAddr1() is the receiving MAC address
@@ -438,7 +575,7 @@
       return;
     }
   // hdr.GetAddr2() is the sending MAC address
-  if (packet->GetSize () == (pktSize + 36)) // ignore non-data frames
+  if (packet->GetSize () >= pktSize) // ignore non-data frames
     {
       IncrementCounter (packetsReceived, hdr.GetAddr2 ());
       IncrementCounter (bytesReceived, hdr.GetAddr2 (), pktSize);
@@ -506,7 +643,7 @@
       break;
     case BUSY_DECODING_PREAMBLE:
     {
-      if (p->GetSize () == (pktSize + 36)) // ignore non-data frames
+      if (p->GetSize () >= pktSize) // ignore non-data frames
         {
           IncrementCounter (rxEventWhileDecodingPreamble, addr);
         }
@@ -514,7 +651,7 @@
     }
     case RXING:
     {
-      if (p->GetSize () == (pktSize + 36)) // ignore non-data frames
+      if (p->GetSize () >= pktSize) // ignore non-data frames
         {
           IncrementCounter (rxEventWhileRxing, addr);
         }
@@ -522,7 +659,7 @@
     }
     case TXING:
     {
-      if (p->GetSize () == (pktSize + 36)) // ignore non-data frames
+      if (p->GetSize () >= pktSize) // ignore non-data frames
         {
           IncrementCounter (rxEventWhileTxing, addr);
         }
@@ -536,7 +673,7 @@
       break;
     case RECEPTION_ABORTED_BY_TX:
     {
-      if (p->GetSize () == (pktSize + 36)) // ignore non-data frames
+      if (p->GetSize () >= pktSize) // ignore non-data frames
         {
           IncrementCounter (rxEventAbortedByTx, addr);
         }
@@ -544,13 +681,15 @@
     }
     case L_SIG_FAILURE:
     {
-      if (p->GetSize () == (pktSize + 36)) // ignore non-data frames
+      if (p->GetSize () >= pktSize) // ignore non-data frames
         {
           IncrementCounter (phyHeaderFailed, addr);
         }
       break;
     }
+    case HT_SIG_FAILURE:
     case SIG_A_FAILURE:
+    case SIG_B_FAILURE:
       NS_FATAL_ERROR ("Unexpected PHY header failure!");
     case PREAMBLE_DETECTION_PACKET_SWITCH:
       NS_FATAL_ERROR ("All devices should send with same power, so no packet switch during preamble detection should occur!");
@@ -577,8 +716,23 @@
 void
 PhyRxOkTrace (std::string context, Ptr<const Packet> p, double snr, WifiMode mode, WifiPreamble preamble)
 {
-  NS_LOG_INFO ("PHY-RX-OK time=" << Simulator::Now () << " node=" << ContextToNodeId (context) << " size=" << p->GetSize () << " snr=" << snr << " mode=" << mode << " preamble=" << preamble);
-  if (p->GetSize () == (pktSize + 36)) // ignore non-data frames
+  uint8_t nMpdus = (p->GetSize () / pktSize);
+  NS_LOG_INFO ("PHY-RX-OK time=" << Simulator::Now ().As (Time::S)
+                                 << " node=" << ContextToNodeId (context)
+                                 << " size=" << p->GetSize ()
+                                 << " nMPDUs=" << +nMpdus
+                                 << " snr=" << snr
+                                 << " mode=" << mode
+                                 << " preamble=" << preamble);
+  if ((maxMpdus != 0) && (nMpdus != 0) && (nMpdus != maxMpdus))
+    {
+      if (nMpdus > maxMpdus)
+        {
+          NS_FATAL_ERROR ("A-MPDU settings not properly applied: maximum configured MPDUs is " << +maxMpdus << " but received an A-MPDU containing " << +nMpdus << " MPDUs");
+        }
+      NS_LOG_WARN ("Warning: less MPDUs aggregated in a received A-MPDU (" << +nMpdus << ") than configured (" << +maxMpdus << ")");
+    }
+  if (p->GetSize () >= pktSize) // ignore non-data frames
     {
       Mac48Address addr = ContextToMac (context);
       IncrementCounter (psduSucceeded, addr);
@@ -589,7 +743,7 @@
 PhyRxErrorTrace (std::string context, Ptr<const Packet> p, double snr)
 {
   NS_LOG_INFO ("PHY-RX-ERROR time=" << Simulator::Now () << " node=" << ContextToNodeId (context) << " size=" << p->GetSize () << " snr=" << snr);
-  if (p->GetSize () == (pktSize + 36)) // ignore non-data frames
+  if (p->GetSize () >= pktSize) // ignore non-data frames
     {
       Mac48Address addr = ContextToMac (context);
       IncrementCounter (psduFailed, addr);
@@ -604,7 +758,7 @@
     {
       phyTxTraceFile << Simulator::Now ().GetSeconds () << " " << ContextToNodeId (context) << " size=" << p->GetSize () << " " << txPowerW << std::endl;
     }
-  if (p->GetSize () == (pktSize + 36)) // ignore non-data frames
+  if (p->GetSize () >= pktSize) // ignore non-data frames
     {
       Mac48Address addr = ContextToMac (context);
       IncrementCounter (packetsTransmitted, addr);
@@ -689,8 +843,29 @@
 {
 public:
   Experiment ();
+
+  /**
+   * Configure and run the experiment.
+   *
+   * \param wifi the pre-configured WifiHelper
+   * \param wifiPhy the pre-configured YansWifiPhyHelper
+   * \param wifiMac the pre-configured WifiMacHelper
+   * \param wifiChannel the pre-configured YansWifiChannelHelper
+   * \param trialNumber the trial index
+   * \param networkSize the number of stations
+   * \param duration the duration of each simulation run
+   * \param pcap flag to enable/disable PCAP files generation
+   * \param infra flag to enable infrastructure model, ring adhoc network if not set
+   * \param guardIntervalNs the guard interval in ns
+   * \param distanceM the distance in meters
+   * \param apTxPowerDbm the AP transmit power in dBm
+   * \param staTxPowerDbm the STA transmit power in dBm
+   * \param pktInterval the packet interval
+   * \return 0 if all went well
+   */
   int Run (const WifiHelper &wifi, const YansWifiPhyHelper &wifiPhy, const WifiMacHelper &wifiMac, const YansWifiChannelHelper &wifiChannel,
-           uint32_t trialNumber, uint32_t networkSize, double duration, bool pcap, bool infra);
+           uint32_t trialNumber, uint32_t networkSize, Time duration, bool pcap, bool infra, uint16_t guardIntervalNs,
+           double distanceM, double apTxPowerDbm, double staTxPowerDbm, Time pktInterval);
 };
 
 Experiment::Experiment ()
@@ -699,7 +874,8 @@
 
 int
 Experiment::Run (const WifiHelper &helper, const YansWifiPhyHelper &wifiPhy, const WifiMacHelper &wifiMac, const YansWifiChannelHelper &wifiChannel,
-                 uint32_t trialNumber, uint32_t networkSize, double duration, bool pcap, bool infra)
+                 uint32_t trialNumber, uint32_t networkSize, Time duration, bool pcap, bool infra, uint16_t guardIntervalNs,
+                 double distance, double apTxPowerDbm, double staTxPowerDbm, Time pktInterval)
 {
   NodeContainer wifiNodes;
   if (infra)
@@ -723,15 +899,19 @@
   if (infra)
     {
       Ssid ssid = Ssid ("wifi-bianchi");
-      uint64_t beaconInterval = std::min<uint64_t> ((ceil ((duration * 1000000) / 1024) * 1024), (65535 * 1024)); //beacon interval needs to be a multiple of time units (1024 us)
+      uint64_t beaconInterval = std::min<uint64_t> ((ceil ((duration.GetSeconds () * 1000000) / 1024) * 1024), (65535 * 1024)); //beacon interval needs to be a multiple of time units (1024 us)
       mac.SetType ("ns3::ApWifiMac",
                    "BeaconInterval", TimeValue (MicroSeconds (beaconInterval)),
                    "Ssid", SsidValue (ssid));
+      phy.Set ("TxPowerStart", DoubleValue (apTxPowerDbm)); 
+      phy.Set ("TxPowerEnd", DoubleValue (apTxPowerDbm));
       devices = wifi.Install (phy, mac, wifiNodes.Get (0));
 
       mac.SetType ("ns3::StaWifiMac",
                    "MaxMissedBeacons", UintegerValue (std::numeric_limits<uint32_t>::max ()),
                    "Ssid", SsidValue (ssid));
+      phy.Set ("TxPowerStart", DoubleValue (staTxPowerDbm)); 
+      phy.Set ("TxPowerEnd", DoubleValue (staTxPowerDbm));
       for (uint32_t i = 1; i < nNodes; ++i)
         {
           devices.Add (wifi.Install (phy, mac, wifiNodes.Get (i)));
@@ -740,11 +920,27 @@
   else
     {
       mac.SetType ("ns3::AdhocWifiMac");
+      phy.Set ("TxPowerStart", DoubleValue (staTxPowerDbm));
+      phy.Set ("TxPowerEnd", DoubleValue (staTxPowerDbm));
       devices = wifi.Install (phy, mac, wifiNodes);
     }
 
   wifi.AssignStreams (devices, trialNumber);
 
+  Config::Set ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/HtConfiguration/ShortGuardIntervalSupported", BooleanValue (guardIntervalNs == 400 ? true : false));
+  Config::Set ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/HeConfiguration/GuardInterval", TimeValue (NanoSeconds (guardIntervalNs)));
+
+  // Configure aggregation
+  for (uint32_t i = 0; i < nNodes; ++i)
+    {
+      Ptr<NetDevice> dev = wifiNodes.Get (i)->GetDevice (0);
+      Ptr<WifiNetDevice> wifi_dev = DynamicCast<WifiNetDevice> (dev);
+      wifi_dev->GetMac ()->SetAttribute ("BE_MaxAmpduSize", UintegerValue (maxMpdus * (pktSize + 50)));
+      wifi_dev->GetMac ()->SetAttribute ("BK_MaxAmpduSize", UintegerValue (maxMpdus * (pktSize + 50)));
+      wifi_dev->GetMac ()->SetAttribute ("VO_MaxAmpduSize", UintegerValue (maxMpdus * (pktSize + 50)));
+      wifi_dev->GetMac ()->SetAttribute ("VI_MaxAmpduSize", UintegerValue (maxMpdus * (pktSize + 50)));
+    }
+
   MobilityHelper mobility;
   Ptr<ListPositionAllocator> positionAlloc = CreateObject<ListPositionAllocator> ();
   mobility.SetMobilityModel ("ns3::ConstantPositionMobilityModel");
@@ -755,7 +951,7 @@
   double angle = (static_cast<double> (360) / (nNodes - 1));
   for (uint32_t i = 0; i < (nNodes - 1); ++i)
     {
-      positionAlloc->Add (Vector (1.0 + (0.001 * cos ((i * angle * PI) / 180)), 1.0 + (0.001 * sin ((i * angle * PI) / 180)), 0.0));
+      positionAlloc->Add (Vector (1.0 + (distance * cos ((i * angle * PI) / 180)), 1.0 + (distance * sin ((i * angle * PI) / 180)), 0.0));
     }
 
   mobility.SetPositionAllocator (positionAlloc);
@@ -783,7 +979,7 @@
       wifiNodes.Get (i)->AddApplication (client);
       client->SetAttribute ("PacketSize", UintegerValue (pktSize));
       client->SetAttribute ("MaxPackets", UintegerValue (0));
-      client->SetAttribute ("Interval", TimeValue (MilliSeconds (1))); //TODO: reduce it for lower rates, increase it for higher rates
+      client->SetAttribute ("Interval", TimeValue (pktInterval));
       double start = startTime->GetValue ();
       NS_LOG_DEBUG ("Client " << i << " starting at " << start);
       client->SetStartTime (Seconds (start));
@@ -831,7 +1027,7 @@
   Config::Connect ("/NodeList/*/$ns3::Node/ApplicationList/*/$ns3::PacketSocketClient/Tx", MakeCallback (&SocketSendTrace));
 
   Simulator::Schedule (Seconds (10), &RestartCalc);
-  Simulator::Stop (Seconds (10 + duration));
+  Simulator::Stop (Seconds (10) + duration);
 
   if (pcap)
     {
@@ -868,20 +1064,27 @@
 
 int main (int argc, char *argv[])
 {
-  uint32_t nMinStas = 5;           ///< Minimum number of STAs to start with
-  uint32_t nMaxStas = 50;          ///< Maximum number of STAs to end with
-  uint32_t nStepSize = 5;          ///< Number of stations to add at each step
-  uint32_t verbose = 0;            ///< verbosity level that increases the number of debugging traces
-  double duration = 100;           ///< duration (in seconds) of each simulation run (i.e. per trial and per number of stations)
-  uint32_t trials = 1;             ///< Number of runs per point in the plot
-  bool pcap = false;               ///< Flag to enable/disable PCAP files generation
-  bool infra = false;              ///< Flag to enable infrastructure model, ring adhoc network if not set
-  std::string workDir = "./";      ///< the working directory to store generated files
-  double phyRate = 54;             ///< the constant PHY rate used to transmit Data frames (in Mbps)
-  std::string standard ("11a");    ///< the 802.11 standard
-  bool validate = false;           ///< Flag used for regression in order to verify ns-3 results are in the expected boundaries
-  uint32_t plotBianchiModel = 0x1; ///< First bit corresponds to the DIFS model, second bit to the EIFS model
-  double maxRelativeError = 0.015; ///< Maximum relative error tolerated between ns-3 results and the Bianchi model (used for regression, i.e. when the validate flag is set)
+  uint32_t nMinStas = 5;                  ///< Minimum number of STAs to start with
+  uint32_t nMaxStas = 50;                 ///< Maximum number of STAs to end with
+  uint32_t nStepSize = 5;                 ///< Number of stations to add at each step
+  uint32_t verbose = 0;                   ///< verbosity level that increases the number of debugging traces
+  double duration = 100;                  ///< duration (in seconds) of each simulation run (i.e. per trial and per number of stations)
+  uint32_t trials = 1;                    ///< Number of runs per point in the plot
+  bool pcap = false;                      ///< Flag to enable/disable PCAP files generation
+  bool infra = false;                     ///< Flag to enable infrastructure model, ring adhoc network if not set
+  std::string workDir = "./";             ///< the working directory to store generated files
+  std::string phyMode = "OfdmRate54Mbps"; ///< the constant PHY mode string used to transmit frames
+  std::string standard ("11a");           ///< the 802.11 standard
+  bool validate = false;                  ///< Flag used for regression in order to verify ns-3 results are in the expected boundaries
+  uint16_t plotBianchiModel = 0x01;        ///< First bit corresponds to the DIFS model, second bit to the EIFS model
+  double maxRelativeError = 0.015;        ///< Maximum relative error tolerated between ns-3 results and the Bianchi model (used for regression, i.e. when the validate flag is set)
+  double frequency = 5;                   ///< The operating frequency band in GHz: 2.4, 5 or 6
+  uint16_t channelWidth = 20;             ///< The constant channel width in MHz (only for 11n/ac/ax)
+  uint16_t guardIntervalNs = 800;         ///< The guard interval in nanoseconds (800 or 400 for 11n/ac, 800 or 1600 or 3200 for 11 ax)
+  uint16_t pktInterval = 1000;            ///< The socket packet interval in microseconds (a higher value is needed to reach saturation conditions as the channel bandwidth or the MCS increases)
+  double distance = 0.001;                ///< The distance in meters between the AP and the STAs
+  double apTxPower = 16;                  ///< The transmit power of the AP in dBm (if infrastructure only)
+  double staTxPower = 16;                 ///< The transmit power of each STA in dBm (or all STAs if adhoc)
 
   // Disable fragmentation and RTS/CTS
   Config::SetDefault ("ns3::WifiRemoteStationManager::FragmentationThreshold", StringValue ("22000"));
@@ -902,13 +1105,22 @@
   cmd.AddValue ("pcap", "Enable/disable PCAP tracing", pcap);
   cmd.AddValue ("infra", "True to use infrastructure mode, false to use ring adhoc mode", infra);
   cmd.AddValue ("workDir", "The working directory used to store generated files", workDir);
-  cmd.AddValue ("phyRate", "Set the constant PHY rate in Mbps used to transmit Data frames", phyRate);
+  cmd.AddValue ("phyMode", "Set the constant PHY mode string used to transmit frames", phyMode);
   cmd.AddValue ("standard", "Set the standard (11a, 11b, 11g, 11n, 11ac, 11ax)", standard);
   cmd.AddValue ("nMinStas", "Minimum number of stations to start with", nMinStas);
   cmd.AddValue ("nMaxStas", "Maximum number of stations to start with", nMaxStas);
   cmd.AddValue ("nStepSize", "Number of stations to add at each step", nStepSize);
+  cmd.AddValue ("plotBianchiModel", "First bit corresponds to the DIFS model, second bit to the EIFS model", plotBianchiModel);
   cmd.AddValue ("validate", "Enable/disable validation of the ns-3 simulations against the Bianchi model", validate);
   cmd.AddValue ("maxRelativeError", "The maximum relative error tolerated between ns-3 results and the Bianchi model (used for regression, i.e. when the validate flag is set)", maxRelativeError);
+  cmd.AddValue ("frequency", "Set the operating frequency band in GHz: 2.4, 5 or 6", frequency);
+  cmd.AddValue ("channelWidth", "Set the constant channel width in MHz (only for 11n/ac/ax)", channelWidth);
+  cmd.AddValue ("guardIntervalNs", "Set the the guard interval in nanoseconds (800 or 400 for 11n/ac, 800 or 1600 or 3200 for 11 ax)", guardIntervalNs);
+  cmd.AddValue ("maxMpdus", "Set the maximum number of MPDUs in A-MPDUs (0 to disable MPDU aggregation)", maxMpdus);
+  cmd.AddValue ("distance", "Set the distance in meters between the AP and the STAs", distance);
+  cmd.AddValue ("apTxPower", "Set the transmit power of the AP in dBm (if infrastructure only)", apTxPower);
+  cmd.AddValue ("staTxPower", "Set the transmit power of each STA in dBm (or all STAs if adhoc)", staTxPower);
+  cmd.AddValue ("pktInterval", "Set the socket packet interval in microseconds", pktInterval);
   cmd.Parse (argc, argv);
 
   if (tracing)
@@ -949,53 +1161,87 @@
     {
       LogComponentEnable ("WifiBianchi", LOG_LEVEL_ALL);
     }
+  else
+    {
+      LogComponentEnable ("WifiBianchi", LOG_LEVEL_WARN);
+    }
   if (verbose >= 2)
     {
       WifiHelper::EnableLogComponents ();
     }
 
+  Config::SetDefault ("ns3::WifiPhy::ChannelWidth", UintegerValue (channelWidth));
+  std::stringstream phyModeStr;
+  phyModeStr << phyMode;
+  if (phyMode.find ("Mcs") != std::string::npos)
+    {
+      phyModeStr << "_" << channelWidth << "MHz";
+    }
+
   std::stringstream ss;
-  ss << "wifi-"<< standard << "-p-" << pktSize << (infra ? "-infrastructure" : "-adhoc") << "-r-" << phyRate << "-min-" << nMinStas << "-max-" << nMaxStas << "-step-" << nStepSize << "-throughput.plt";
+  ss << "wifi-"<< standard << "-p-" << pktSize << (infra ? "-infrastructure" : "-adhoc") << "-r-" << phyModeStr.str () << "-min-" << nMinStas << "-max-" << nMaxStas << "-step-" << nStepSize << "-throughput.plt";
   std::ofstream throughputPlot (ss.str ().c_str ());
   ss.str ("");
-  ss << "wifi-" << standard << "-p-" << pktSize << (infra ? "-infrastructure" : "-adhoc") <<"-r-" << phyRate << "-min-" << nMinStas << "-max-" << nMaxStas << "-step-" << nStepSize << "-throughput.eps";
+  ss << "wifi-" << standard << "-p-" << pktSize << (infra ? "-infrastructure" : "-adhoc") <<"-r-" << phyModeStr.str () << "-min-" << nMinStas << "-max-" << nMaxStas << "-step-" << nStepSize << "-throughput.eps";
   Gnuplot gnuplot = Gnuplot (ss.str ());
 
   WifiStandard wifiStandard;
-  std::stringstream phyRateStr;
   if (standard == "11a")
     {
       wifiStandard = WIFI_STANDARD_80211a;
-      if ((phyRate != 6) && (phyRate != 9) && (phyRate != 12) && (phyRate != 18) && (phyRate != 24) && (phyRate != 36) && (phyRate != 48) && (phyRate != 54))
-        {
-          NS_FATAL_ERROR ("Selected PHY rate " << phyRate << " is not defined in " << standard);
-        }
-      phyRateStr << "OfdmRate" << phyRate << "Mbps";
+      frequency = 5;
+      channelWidth = 20;
     }
   else if (standard == "11b")
     {
       wifiStandard = WIFI_STANDARD_80211b;
-      if ((phyRate != 1) && (phyRate != 2) && (phyRate != 5.5) && (phyRate != 11))
+      frequency = 2.4;
+      channelWidth = 22;
+    }
+  else if (standard == "11g")
+    {
+      wifiStandard = WIFI_STANDARD_80211g;
+      frequency = 2.4;
+      channelWidth = 20;
+    }
+  else if (standard == "11n")
+    {
+      if (frequency == 2.4)
         {
-          NS_FATAL_ERROR ("Selected PHY rate " << phyRate << " is not defined in " << standard);
+          wifiStandard = WIFI_STANDARD_80211n_2_4GHZ;
         }
-      if (phyRate == 5.5)
+      else if (frequency == 5)
         {
-          phyRateStr << "DsssRate5_5Mbps";
+          wifiStandard = WIFI_STANDARD_80211n_5GHZ;
         }
       else
         {
-          phyRateStr << "DsssRate" << phyRate << "Mbps";
+          NS_FATAL_ERROR ("Unsupported frequency band " << frequency << " GHz for standard " << standard);
         }
     }
-  else if (standard == "11g")
+  else if (standard == "11ac")
     {
-      wifiStandard = WIFI_STANDARD_80211g;
-      if ((phyRate != 6) && (phyRate != 9) && (phyRate != 12) && (phyRate != 18) && (phyRate != 24) && (phyRate != 36) && (phyRate != 48) && (phyRate != 54))
+      wifiStandard = WIFI_STANDARD_80211ac;
+      frequency = 5;
+    }
+  else if (standard == "11ax")
+    {
+      if (frequency == 2.4)
+        {
+          wifiStandard = WIFI_STANDARD_80211ax_2_4GHZ;
+        }
+      else if (frequency == 5)
+        {
+          wifiStandard = WIFI_STANDARD_80211ax_5GHZ;
+        }
+      else if (frequency == 6)
+        {
+          wifiStandard = WIFI_STANDARD_80211ax_6GHZ;
+        }
+      else
         {
-          NS_FATAL_ERROR ("Selected PHY rate " << phyRate << " is not defined in " << standard);
+          NS_FATAL_ERROR ("Unsupported frequency band " << frequency << " GHz for standard " << standard);
         }
-      phyRateStr << "ErpOfdmRate" << phyRate << "Mbps";
     }
   else
     {
@@ -1003,16 +1249,40 @@
     }
 
   YansWifiPhyHelper wifiPhy;
-  YansWifiChannelHelper wifiChannel;
-  wifiChannel.SetPropagationDelay ("ns3::ConstantSpeedPropagationDelayModel");
-  wifiChannel.AddPropagationLoss ("ns3::LogDistancePropagationLossModel");
   wifiPhy.DisablePreambleDetectionModel ();
 
-  WifiMacHelper wifiMac;
+  YansWifiChannelHelper wifiChannel;
+  wifiChannel.SetPropagationDelay ("ns3::ConstantSpeedPropagationDelayModel");
+  if (frequency == 6)
+    {
+      // Reference Loss for Friss at 1 m with 6.0 GHz
+      wifiChannel.AddPropagationLoss ("ns3::LogDistancePropagationLossModel",
+                                      "Exponent", DoubleValue (2.0),
+                                      "ReferenceDistance", DoubleValue (1.0),
+                                      "ReferenceLoss", DoubleValue (49.013));
+    }
+  else if (frequency == 5)
+    {
+      // Reference Loss for Friss at 1 m with 5.15 GHz
+      wifiChannel.AddPropagationLoss ("ns3::LogDistancePropagationLossModel",
+                                      "Exponent", DoubleValue (2.0),
+                                      "ReferenceDistance", DoubleValue (1.0),
+                                      "ReferenceLoss", DoubleValue (46.6777));
+    }
+  else
+    {
+      // Reference Loss for Friss at 1 m with 2.4 GHz
+      wifiChannel.AddPropagationLoss ("ns3::LogDistancePropagationLossModel",
+                                      "Exponent", DoubleValue (2.0),
+                                      "ReferenceDistance", DoubleValue (1.0),
+                                      "ReferenceLoss", DoubleValue (40.046));
+    }
 
   WifiHelper wifi;
   wifi.SetStandard (wifiStandard);
-  wifi.SetRemoteStationManager ("ns3::ConstantRateWifiManager", "DataMode", StringValue (phyRateStr.str()));
+  wifi.SetRemoteStationManager ("ns3::ConstantRateWifiManager",
+                                "DataMode", StringValue (phyMode),
+                                "ControlMode", StringValue (phyMode));
 
   Gnuplot2dDataset dataset;
   Gnuplot2dDataset datasetBianchiEifs;
@@ -1023,6 +1293,7 @@
   datasetBianchiDifs.SetStyle (Gnuplot2dDataset::LINES_POINTS);
 
   Experiment experiment;
+  WifiMacHelper wifiMac;
   double averageThroughput, throughputArray[trials];
   for (uint32_t n = nMinStas; n <= nMaxStas; n += nStepSize)
     {
@@ -1044,17 +1315,17 @@
           rxEventAbortedByTx.clear ();
           associated.clear ();
           throughput = 0;
-          std::cout << "Trial " << runIndex + 1 << " of " << trials << "; "<< phyRate << " Mbps for " << n << " nodes " << std::endl;
+          std::cout << "Trial " << runIndex + 1 << " of " << trials << "; "<< phyModeStr.str () << " for " << n << " nodes " << std::endl;
           if (tracing)
             {
-              cwTraceFile << "# Trial " << runIndex + 1 << " of " << trials << "; "<< phyRate << " Mbps for " << n << " nodes" << std::endl;
-              backoffTraceFile << "# Trial " << runIndex + 1 << " of " << trials << "; "<< phyRate << " Mbps for " << n << " nodes" << std::endl;
-              phyTxTraceFile << "# Trial " << runIndex + 1 << " of " << trials << "; " << phyRate << " Mbps for " << n << " nodes" << std::endl;
-              macTxTraceFile << "# Trial " << runIndex + 1 << " of " << trials << "; " << phyRate << " Mbps for " << n << " nodes" << std::endl;
-              macRxTraceFile << "# Trial " << runIndex + 1 << " of " << trials << "; " << phyRate << " Mbps for " << n << " nodes" << std::endl;
-              socketSendTraceFile << "# Trial " << runIndex + 1 << " of " << trials << "; " << phyRate << " Mbps for " << n << " nodes" << std::endl;
+              cwTraceFile << "# Trial " << runIndex + 1 << " of " << trials << "; "<< phyModeStr.str () << " for " << n << " nodes" << std::endl;
+              backoffTraceFile << "# Trial " << runIndex + 1 << " of " << trials << "; "<< phyModeStr.str () << " for " << n << " nodes" << std::endl;
+              phyTxTraceFile << "# Trial " << runIndex + 1 << " of " << trials << "; " << phyModeStr.str () << " for " << n << " nodes" << std::endl;
+              macTxTraceFile << "# Trial " << runIndex + 1 << " of " << trials << "; " << phyModeStr.str () << " for " << n << " nodes" << std::endl;
+              macRxTraceFile << "# Trial " << runIndex + 1 << " of " << trials << "; " << phyModeStr.str () << " for " << n << " nodes" << std::endl;
+              socketSendTraceFile << "# Trial " << runIndex + 1 << " of " << trials << "; " << phyModeStr.str () << " for " << n << " nodes" << std::endl;
             }
-          experiment.Run (wifi, wifiPhy, wifiMac, wifiChannel, runIndex, n, duration, pcap, infra);
+          experiment.Run (wifi, wifiPhy, wifiMac, wifiChannel, runIndex, n, Seconds (duration), pcap, infra, guardIntervalNs, distance, apTxPower, staTxPower, MicroSeconds (pktInterval));
           uint32_t k = 0;
           if (bytesReceived.size () != n)
             {
@@ -1105,7 +1376,7 @@
       bool rateFound = false;
       double relativeErrorDifs = 0;
       double relativeErrorEifs = 0;
-      auto itDifs = bianchiResultsDifs.find (static_cast<unsigned int> (phyRate * 1000000));
+      auto itDifs = bianchiResultsDifs.find (phyModeStr.str ());
       if (itDifs != bianchiResultsDifs.end ())
         {
           rateFound = true;
@@ -1120,7 +1391,7 @@
               NS_FATAL_ERROR ("No Bianchi results (DIFS) calculated for that number of stations!");
             }
         }
-      auto itEifs = bianchiResultsEifs.find (static_cast<unsigned int> (phyRate * 1000000));
+      auto itEifs = bianchiResultsEifs.find (phyModeStr.str ());
       if (itEifs != bianchiResultsEifs.end ())
         {
           rateFound = true;
@@ -1155,7 +1426,7 @@
     }
   dataset.SetTitle ("ns-3");
 
-  auto itDifs = bianchiResultsDifs.find (static_cast<unsigned int> (phyRate * 1000000));
+  auto itDifs = bianchiResultsDifs.find (phyModeStr.str ());
   if (itDifs != bianchiResultsDifs.end ())
     {
       for (uint32_t i = nMinStas; i <= nMaxStas; i += nStepSize)
@@ -1177,7 +1448,7 @@
         }
     }
 
-  auto itEifs = bianchiResultsEifs.find (static_cast<unsigned int> (phyRate * 1000000));
+  auto itEifs = bianchiResultsEifs.find (phyModeStr.str ());
   if (itEifs != bianchiResultsEifs.end ())
     {
       for (uint32_t i = nMinStas; i <= nMaxStas; i += nStepSize)
@@ -1222,17 +1493,17 @@
      << "set style line 8 linewidth 5\n"
      << "set style increment user";
   gnuplot.SetExtra (ss.str ());
-  if (plotBianchiModel & 0x01)
+  if (plotBianchiModel & 0x0001)
     {
       datasetBianchiDifs.SetTitle ("Bianchi");
       gnuplot.AddDataset (datasetBianchiDifs);
     }
-  if (plotBianchiModel & 0x02)
+  if (plotBianchiModel & 0x0002)
     {
       datasetBianchiEifs.SetTitle ("Bianchi");
       gnuplot.AddDataset (datasetBianchiEifs);
     }
-  if (plotBianchiModel == 0x03)
+  if (plotBianchiModel == 0x0003)
     {
       datasetBianchiEifs.SetTitle ("Bianchi (EIFS - lower bound)");
       datasetBianchiDifs.SetTitle ("Bianchi (DIFS - upper bound)");
